---
title: Create a custom detection location for a zone.
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/python)

[Leaked Credential Checks](https://developers.cloudflare.com/api/python/resources/leaked_credential_checks)

[Detections](https://developers.cloudflare.com/api/python/resources/leaked_credential_checks/subresources/detections)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Create a custom detection location for a zone.

leaked\_credential\_checks.detections.create(DetectionCreateParams\*\*kwargs) -> [DetectionCreateResponse](<https://developers.cloudflare.com/api/python/resources/leaked_credential_checks#(resource)%20leaked_credential_checks.detections%20%3E%20(model)%20detection_create_response%20%3E%20(schema)>)

POST/zones/{zone\_id}/leaked-credential-checks/detections

Create a detection location for credentials that the default scan locations do not cover, using Rules language expressions such as `lookup_json_string(http.request.body.raw, "user")`. Only the username expression is required, and Leaked Credential Checks must be enabled on the zone.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Zone WAF Write``Account WAF Write`

##### ParametersExpand Collapse

zone\_id: str

Defines an identifier.

maxLength32

[Link to this property](<#(resource)%20leaked_credential_checks.detections%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20zone_id%20%3E%20(schema)>)

password: Optional\[str]

Defines ehe ruleset expression to use in matching the password in a request.

[Link to this property](<#(resource)%20leaked_credential_checks.detections%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20password%20%3E%20(schema)>)

username: Optional\[str]

Defines the ruleset expression to use in matching the username in a request.

[Link to this property](<#(resource)%20leaked_credential_checks.detections%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20username%20%3E%20(schema)>)

##### ReturnsExpand Collapse

<details>

<summary>

class DetectionCreateResponse: …

Defines a custom set of username/password expressions to match Leaked Credential Checks on.

</summary>

id: Optional\[str]

Defines the unique ID for this custom detection.

maxLength32

<a href="#(resource)%20leaked_credential_checks.detections%20%3E%20(model)%20detection_create_response%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

password: Optional\[str]

Defines ehe ruleset expression to use in matching the password in a request.

<a href="#(resource)%20leaked_credential_checks.detections%20%3E%20(model)%20detection_create_response%20%3E%20(schema)%20%3E%20(property)%20password">Link to this property</a>

username: Optional\[str]

Defines the ruleset expression to use in matching the username in a request.

<a href="#(resource)%20leaked_credential_checks.detections%20%3E%20(model)%20detection_create_response%20%3E%20(schema)%20%3E%20(property)%20username">Link to this property</a>

</details>

[Link to this property](<#(resource)%20leaked_credential_checks.detections%20%3E%20(model)%20detection_create_response%20%3E%20(schema)>)

### Create a custom detection location for a zone.

Python

HTTPTypeScriptPythonGoTerraform

```
import os
from cloudflare import Cloudflare

client = Cloudflare(
    api_token=os.environ.get("CLOUDFLARE_API_TOKEN"),  # This is the default and can be omitted
)
detection = client.leaked_credential_checks.detections.create(
    zone_id="023e105f4ecef8ad9ca31a8372d0c353",
)
print(detection.id)
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "18a14bafaa8eb1df04ce683ec18c765e",
    "password": "lookup_json_string(http.request.body.raw, \"secret\")",
    "username": "lookup_json_string(http.request.body.raw, \"user\")"
  },
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "18a14bafaa8eb1df04ce683ec18c765e",
    "password": "lookup_json_string(http.request.body.raw, \"secret\")",
    "username": "lookup_json_string(http.request.body.raw, \"user\")"
  },
  "success": true
}
```